comonad-5: Comonads

Copyright | (C) 2008-2015 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | experimental
Portability | non-portable (fundeps, MPTCs)
Safe Haskell | Safe
Language | Haskell2010

Control.Comonad.Env.Class

Description

# Documentation

class Comonad w => ComonadEnv e w | w -> e where #

Minimal complete definition

ask

Methods

ask :: w a -> e #

Instances

ComonadEnv e (Arg e) # |
Methods ask :: Arg e a -> e #
ComonadEnv e ((,) e) # |
Methods ask :: (e, a) -> e #
(ComonadEnv e w, Monoid m) => ComonadEnv e (TracedT m w) # |
Methods ask :: TracedT m w a -> e #
ComonadEnv e w => ComonadEnv e (IdentityT * w) # |
Methods ask :: IdentityT * w a -> e #
ComonadEnv e w => ComonadEnv e (StoreT t w) # |
Methods ask :: StoreT t w a -> e #
Comonad w => ComonadEnv e (EnvT e w) # |
Methods ask :: EnvT e w a -> e #

asks :: ComonadEnv e w => (e -> e') -> w a -> e' #